<template>
  <div v-if="supportedType" class="rui-field__field">
    <select v-if="prop.values.length > 0" v-model="internalValue" :required="isRequired">
      <option :value="null" disabled>{{ placeholderValue }}</option>
      <option v-for="value in prop.values" :key="value" :value="value">{{ value }}</option>
    </select>

    <input v-else-if="propIs('string')"
           v-model="internalValue"
           type="text"
           :placeholder="placeholderValue"
           :required="isRequired">

    <input v-else-if="propIs('number')"
           v-model="internalValue"
           type="number"
           :placeholder="placeholderValue"
           :required="isRequired">

    <input v-else-if="propIs('date')"
           v-model="internalValue"
           type="date"
           :placeholder="placeholderValue"
           :required="isRequired">

    <input v-else-if="propIs('boolean')"
           v-model="internalValue"
           type="checkbox"
           :value="true">

    <small v-if="internalValue === null" class="rui-field__field__append">(default used: <code>{{ placeholderValue }}</code>)</small>
    <rui-button v-else
                icon="trash"
                variant="destructive"
                :class="propIs('boolean') ? '' : 'rui-field__field__append'"
                @click="internalValue = null" />
  </div>

  <markdown-renderer v-if="prop.description" class="rui-field__help" :raw="prop.description" />

  <div v-if="!supportedType" class="-text--smaller">
    <div v-if="modelValue">
      <p>The value provided for this example is:</p>
      <pre>{{ modelValue }}</pre>
    </div>
    <rui-empty v-else icon="smiley-meh" class="-mtd" inline>No value has been passed in the example.</rui-empty>

    <div class="-text--warning -mtd">Note: Type <code>{{ prop.type.name }}</code> is not supported in the playground.</div>
  </div>
</template>

<script>
import MarkdownRenderer from './MarkdownRenderer.vue'

export default {
  name: 'PropControl',
  emits: [
    'update:modelValue',
  ],
  components: { MarkdownRenderer },
  props: {
    prop: { required: true, type: Object },
    modelValue: { required: false, type: [String, Number, Boolean, null], default: null },
  },
  data () {
    return {
      internalValue: this.modelValue,
    }
  },
  computed: {
    isRequired () { return this.prop.required },
    supportedType () {
      const chunks = this.prop.type.name.split('|')
      const types = [
        'number',
        'string',
        'date',
        'boolean',
      ]

      for (const c of chunks) { if (types.includes(c)) return true }
      return false
    },
    placeholderValue () { return this.prop.defaultValue?.value },
  },
  methods: {
    propIs (type) { return this.prop.type.name.includes(type) },
  },
  watch: {
    modelValue (newValue) { this.internalValue = newValue },
    internalValue (newValue, oldValue) {
      if (newValue === oldValue) return

      this.$emit('update:modelValue', newValue)
    },
  },
}
</script>
